<?php

/*
 * Genera una clave aleatoria de X a Y numeros de caracteres
 * 
 * Ejemplo:  generar_clave(10, 12)
 */
function generar_clave($minimo = 6, $maximo = 8)
{
	$clave = "";
	$caracteres = "ABCDEFGHIJKLMNOPRSTUVWXYZ";
	
	for ($i = 0; $i < rand($minimo, $maximo); $i++)
	{
		$clave .= $caracteres[rand(0, strlen($caracteres) - 1)];
	}
	
	return $clave;
}

// Tomar una clave aleatoria, cifrarla en base64 y mover los caracteres 13 posiciones (solo letras)
$clave = generar_clave();
$clave = str_rot13(base64_encode($clave));

?>
<html>
<head>
<meta http-equiv="content-type" charset="utf-8">
</head>
<body>
<form name="formulario" action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
	<?php
    // Si se recibe una clave captcha se puede verificar
	if (isset($_POST['c'])) :
	?>
    	<div align="center" style="font-family: Verdana,Geneva,sans-serif; font-size: 14px;">
		<?php
		// Decifrar la clave del captcha y compararla con el texto introducido (convertido a mayusculas) 
		if (base64_decode(str_rot13($_POST['c'])) == strtoupper($_POST['captcha'])) :
		?>
			<b>¡Correcto!</b>
		<?php
        else :
		?>
			<b>¡Incorrecto!</b>
		<?php
        endif;
		?>
		</div>
	<?php
    endif;
	?>
    <br />
    <div align="center">
    	<img src="captcha.php?c=<?php echo $clave; ?>" alt="Captcha">
    </div>
    <br />
    <div align="center" style="font-family: Verdana,Geneva,sans-serif; font-size: 14px;">
    	Captcha: <input type="text" name="captcha" value="" />
        <br />
        <br />
        <input type="submit" name="verificar" value="Verificar" />
    </div>
    <input type="hidden" name="c" value="<?php echo $clave; ?>" />
</form>
</body>
</html>